# -*- coding: utf8 -*-

import urllib2, time, inspect, string, sys, re, csv
import htmlparser, curvas

#import mod_mysql, infodb
#dbusr,dbclv = infodb.get()
#bdd = mod_mysql.DataBase("localhost", dbusr, dbclv, "roundup")

VARIABS = "component version priority severity".split()
URL_CSV = "http://bugs.python.org/issue?@action=export_csv&@columns=id,title,keywords,priority,versions,severity,components&@sort=creation&@filter=status&status=1,3"
URL_BASE = "http://bugs.python.org/%s"

FADAPT = { 19 : "%Y-%m-%d.%H:%M:%S",
           18 : "%Y-%m-%d%H:%M:%S",
         }
FFECHA = "%Y-%m-%d"
NOPRE = re.compile("<pre>.*?</pre>", re.S)

class MakeHTML(object):
    def __init__(self, lineas):
        self.titulo = "Python Open Tickets"
        self._rows = []
        self._anchoTiempo = 400

    def addRow(self, args):
        self._rows.append(args)

    def _calculoFechas(self):
        # calculamos los valores desde y hasta
        oldest_fecha = last_fecha = None
        for row in self._rows:
#            print row
            (id, summ, abr_by, abr_when, ult_by, ult_when, url, activs, kwds) = row
            if oldest_fecha is None or abr_when < oldest_fecha:
                oldest_fecha = abr_when
                oldest_quien = abr_by
            if last_fecha is None or ult_when > last_fecha:
                last_fecha = ult_when
                last_quien = ult_by

        self.desde = time.mktime(time.strptime(oldest_fecha, FFECHA))
        hasta = time.mktime(time.strptime(last_fecha, FFECHA)) + 1
        delta = hasta-self.desde
        self.paso = self._anchoTiempo/delta
        return (oldest_fecha, oldest_quien, last_fecha, last_quien)

    def _armaConteo(self, puntos):
        # contamos cuantos hay por dia
        conteo = {}
        for p in puntos:
            if p >= self._anchoTiempo:
                raise ValueError("Recibi un punto (%d) fuera de escala (%d)" % (p, self._anchoTiempo))
            conteo[p] = conteo.get(p, 0) + 1
        puntos = sorted(conteo.items())
        if id == "588756":
            print puntos

        base = ["f"]*self._anchoTiempo
        for i in range(puntos[0][0], puntos[-1][0]):
            base[i] = "b"

        for pos,ancho in puntos:
            while pos<self._anchoTiempo and base[pos] == "m":
                pos += 1
            for i in range(ancho):
                if pos+i < self._anchoTiempo:
                    base[pos+i] = "m"

        ini = 0
        pos = 1
        ant = base[0]
        marcas = []
        while pos < self._anchoTiempo:
            if base[pos] != ant:
                marcas.append((ant, pos-ini))
                ant = base[pos]
                ini = pos
            pos += 1

        marcas.append((ant, pos-ini))
        return marcas

    def _getSuperTabla(self, p_ini, p_fin):
        filas = []
        for row in self._rows[p_ini:p_fin]:
#            log("Cargando: ", row)
            (id, summ, abr_by, abr_when, ult_by, ult_when, url, activs, kwds) = row

            # arrancamos la fila
            fila = ' <tr>\n'
            fila += '  <td><a href="%s">%s</a></td>\n' % (url, id)
            fila += '  <td>%s</td>\n' % kwds
            fila += '  <td>%s</td>\n' % summ
            fila += '  <td>%s <i>(%s)</i></td>\n' % (abr_by, abr_when)

            # hacemos anchas las marcas en funcion de la cantidad en el mismo dia
            puntos = [int((x-self.desde) * self.paso) for x in activs]
            marcas = self._armaConteo(puntos)
            fila += '  <td>'
            for marc,ancho in marcas:
                fila += '<img src="%s.png" width="%d"/>' % (marc, ancho)
            fila += '  </td>'

            # cerramos la fila
            if abr_by == ult_by and abr_when == ult_when:
                fila += '  <td>-</td>\n'
            else:
                fila += '  <td>%s <i>(%s)</i></td>\n' % (ult_by, ult_when)
            fila += ' </tr>\n'
            filas.append(fila)
        return "\n".join(filas)

    def _paginador(self):
        p_ini = 0
        pag = -1
        cant = len(self._rows)
        for pag, p_fin in enumerate(range(CANTPAG-1, cant, CANTPAG)):
            yield (p_ini, p_fin, pag)
            p_ini = p_fin + 1
        if p_ini == cant:
            return
        yield (p_ini, cant, pag+1)

    def _getInfoPaginado(self, estapag):
        filas = []
        for (p_ini, p_fin, pag) in self._paginador():
            # el ini y fin están cruzados porque el órden de la tabla es
            # descendente en sus IDs
            item_fin = self._rows[p_ini][0]
            item_ini = self._rows[p_fin-1][0]
            texto = "%s<br/>to<br/>%s" % (item_ini, item_fin)
            if pag != estapag:
                texto = '<a href="%s">%s</a>' % (self.outfile % pag, texto)
            else:
                item_desde = item_ini
                item_hasta = item_fin
            campo = '    <td align="center">%s</td>' % texto
            filas.append(campo)
        return ("\n".join(filas), item_desde, item_hasta)

    def generaFinalDoc(self):
        # valores repetidos en las paginas
        (oldest_fecha, oldest_quien, last_fecha, last_quien) = self._calculoFechas()
        titulo = self.titulo
        cant_registros = len(self._rows)
        updated = time.ctime()
        ancho_total = self._anchoTiempo + 2
        kwdfilter_active = self.kwd

        # cargamos el template
        arch = open("./resumen.template")
        template = string.Template(arch.read())

        # paginamos
        for (p_ini, p_fin, pag) in self._paginador():
            # armamos la info
            log("Eligiendo desde %s al %s para la pag %d" % (p_ini, p_fin, pag))
            (paginado_links, item_desde, item_hasta) = self._getInfoPaginado(pag)
            registros_tabla = self._getSuperTabla(p_ini, p_fin)

            # reemplazamos en el template y grabamos
            html = template.substitute(locals())
            a = open(self.outfile % pag, "w")
            a.write(html)
            a.close()
        return


def getInfo(version=None, component=None, keyword=None, priority=None, severity=None):
    # las que cruzan
    qfrom = "items"
    qwhere = ""
    if version is not None:
        qfrom = " (%s) inner join item_versions using (elemid)" % qfrom
        qwhere += " and item_versions.cod=%d" % version
    if component is not None:
        qfrom = " (%s) inner join item_components using (elemid)" % qfrom
        qwhere += " and item_components.cod=%d" % component
    if keyword is not None:
        qfrom = " (%s) inner join item_keywords using (elemid)" % qfrom
        qwhere += " and item_keywords.cod=%d" % keyword
    qfrom = " (%s) inner join priority on (items.priority=priority.kw)" % qfrom
    qfrom = " (%s) inner join severity on (items.severity=severity.kw)" % qfrom

    # las que filtran
    if priority is not None:
        qwhere += " and priority=%d" % int(priority)
    if severity is not None:
        qwhere += " and severity=%d" % int(severity)

    # sanitizamos qfrom y qwhere
    while "(items)" in qfrom:
        qfrom = qfrom.replace("(items)", "items")
    qwhere = qwhere[5:]

    # armamos
    qbase = "select items.elemid, title, creat_by, creat_dt, lastc_by, lastc_dt, priority.descrip, severity.descrip all_components, all_versions, all_keywords from"
    query = "%s %s where %s;" % (qbase, qfrom, qwhere)
    print "qqq- ", query

    # armamos el documento
    lineas = bdd.accion(query)
    print "Cant:", len(lineas)
    html = MakeHTML(lineas)
    result = html.generaFinalDoc()
    return result

if __name__ == "__main__":
#    getInfo(version=12, priority=4, component=9)
    getInfo(version=12)
